glibmm: Gio::SimpleIOStream Class Reference

glibmm 2.66.10

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gio::SimpleIOStream Class Reference
Stream Classes

A wrapper around an input and an output stream. More...

`#include <giomm/simpleiostream.h>`

Inheritance diagram for Gio::SimpleIOStream:
[legend]

## Public Member Functions
| SimpleIOStream (SimpleIOStream && src) noexcept
SimpleIOStream & | operator= (SimpleIOStream && src) noexcept
| ~SimpleIOStream () noexcept override
GSimpleIOStream * | gobj ()
| Provides access to the underlying C GObject.
const GSimpleIOStream * | gobj () const
| Provides access to the underlying C GObject.
GSimpleIOStream * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< InputStream > > | property_input_stream () const
| The GInputStream to read from.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< OutputStream > > | property_output_stream () const
| The GOutputStream to write to.
Public Member Functions inherited from Gio::IOStream
| IOStream (IOStream && src) noexcept
IOStream & | operator= (IOStream && src) noexcept
| ~IOStream () noexcept override
GIOStream * | gobj ()
| Provides access to the underlying C GObject.
const GIOStream * | gobj () const
| Provides access to the underlying C GObject.
GIOStream * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | splice_async (const Glib::RefPtr< IOStream > & stream2, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, IOStreamSpliceFlags flags=Gio::IO_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| Asyncronously splice the output stream to the input stream of stream2, and splice the output stream of stream2 to the input stream of this stream.
void | splice_async (const Glib::RefPtr< IOStream > & stream2, const SlotAsyncReady & slot, IOStreamSpliceFlags flags=Gio::IO_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| A non-cancellable version of splice_async().
Glib::RefPtr< InputStream > | get_input_stream ()
| Gets the input stream for this object.
Glib::RefPtr< OutputStream > | get_output_stream ()
| Gets the output stream for this object.
bool | close (const Glib::RefPtr< Cancellable > & cancellable)
| Closes the stream, releasing resources related to it.
bool | close ()
| A close() convenience overload.
void | close_async (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
void | close_async (const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
bool | close_finish (const Glib::RefPtr< AsyncResult > & result)
| Closes a stream.
bool | is_closed () const
| Checks if a stream is closed.
bool | has_pending () const
| Checks if a stream has pending actions.
bool | set_pending ()
| Sets stream to have actions pending.
void | clear_pending ()
| Clears the pending flag on stream.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void * data)
void | set_data (const Quark & key, void * data, DestroyNotify notify)
void | remove_data (const QueryQuark & quark)
void * | steal_data (const QueryQuark & quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void > & slot)
| You can use the signal_changed() signal of the property proxy instead.
void | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void > && slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed_with_return (const Glib::ustring & property_name, const sigc::slot< void > & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed_with_return (const Glib::ustring & property_name, sigc::slot< void > && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< SimpleIOStream > | create (const Glib::RefPtr< InputStream > & input_stream, const Glib::RefPtr< OutputStream > & output_stream)
| Creates a new SimpleIOStream wrapping input_stream and output_stream.
Static Public Member Functions inherited from Gio::IOStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static bool | splice_finish (const Glib::RefPtr< AsyncResult > & result)
| Finishes an asynchronous io stream splice operation.

## Protected Member Functions
| SimpleIOStream (const Glib::RefPtr< InputStream > & input_stream, const Glib::RefPtr< OutputStream > & output_stream)
| Creates a new SimpleIOStream wrapping input_stream and output_stream.
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams & construct_params)
| Object (GObject * castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::SimpleIOStream > | wrap (GSimpleIOStream * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gio::IOStream
Glib::RefPtr< Gio::IOStream > | wrap (GIOStream * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject * object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void (*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

A wrapper around an input and an output stream.

SimpleIOStream creates an IOStream from an arbitrary InputStream and OutputStream. This allows any pair of input and output streams to be used with IOStream methods.

This is useful when you obtained an InputStream and an OutputStream by other means, for instance creating them with platform specific methods such as Gio::UnixInputStream::create(), and you want to take advantage of the methods provided by IOStream.

Since glibmm 2.46

## Constructor & Destructor Documentation

## ◆ SimpleIOStream() [1/2]

Gio::SimpleIOStream::SimpleIOStream | ( | SimpleIOStream && | src | ) |
| noexcept

## ◆ ~SimpleIOStream()

Gio::SimpleIOStream::~SimpleIOStream | ( |  | ) |
| overridenoexcept

## ◆ SimpleIOStream() [2/2]

Gio::SimpleIOStream::SimpleIOStream | ( | const Glib::RefPtr< InputStream > & | input_stream,
|  | const Glib::RefPtr< OutputStream > & | output_stream )
| explicitprotected

Creates a new SimpleIOStream wrapping input_stream and output_stream.

See also
  IOStream

Since glibmm 2.46

Parameters

  input_stream | An InputStream.
  output_stream | An OutputStream.

Returns
  A new SimpleIOStream instance.

## Member Function Documentation

## ◆ create()

Glib::RefPtr< SimpleIOStream > Gio::SimpleIOStream::create | ( | const Glib::RefPtr< InputStream > & | input_stream,
|  | const Glib::RefPtr< OutputStream > & | output_stream )
| static

Creates a new SimpleIOStream wrapping input_stream and output_stream.

See also
  IOStream

Since glibmm 2.46

Parameters

  input_stream | An InputStream.
  output_stream | An OutputStream.

Returns
  A new SimpleIOStream instance.

## ◆ get_type()

GType Gio::SimpleIOStream::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GSimpleIOStream * Gio::SimpleIOStream::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GSimpleIOStream * Gio::SimpleIOStream::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GSimpleIOStream * Gio::SimpleIOStream::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

SimpleIOStream & Gio::SimpleIOStream::operator= | ( | SimpleIOStream && | src | ) |
| noexcept

## ◆ property_input_stream()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< InputStream > > Gio::SimpleIOStream::property_input_stream | ( |  | ) | const

The GInputStream to read from.

Since glibmm 2.46

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_output_stream()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< OutputStream > > Gio::SimpleIOStream::property_output_stream | ( |  | ) | const

The GOutputStream to write to.

Since glibmm 2.46

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::SimpleIOStream > wrap | ( | GSimpleIOStream * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.